#ifndef misc_h
#define misc_h

#define ERR (-1)
#define	new(type)	((type *)ecalloc(1,sizeof(type)))

typedef struct List List;
struct List{
	void *data;
	List *next;
};


typedef struct Rdbuf Rdbuf;
struct Rdbuf
{
	int fd;
	int size;
	char *sp,*cp,*ep,*bp;
};

void *emalloc(ulong n);
void *ecalloc(ulong n, ulong elsize);
char *estrdup(char *str);

List *Lpush(List *root, void *data);
List *Lappend(List *p, void *d);
void Lfree(List *p);

Rdbuf *rdinit(int fd, int size);
void rdfree(Rdbuf *rb);
char *rdline(Rdbuf *rb);
int rdlnlen(Rdbuf *rb);

int split(char *str, char **args, int max, int sep);
void strtolower(char *s);
char *skip(char *s, char *p);
char *skipto(char *s, char *p);
int chkutf(char *s);
char *skipnrune(char *p, int n);

#endif
